<?php
/**
 * Clients section
 *
 * This is the template for the content of clients section
 *
 * @package Theme Palace
 * @subpackage Myself Pro
 * @since Myself Pro 1.0.0
 */
if ( ! function_exists( 'myself_pro_add_clients_section' ) ) :
    /**
    * Add clients section
    *
    *@since Myself Pro 1.0.0
    */
    function myself_pro_add_clients_section() {
    	$options = myself_pro_get_theme_options();
        // Check if clients is enabled on frontpage
        $clients_enable = apply_filters( 'myself_pro_section_status', true, 'clients_section_enable' );

        if ( true !== $clients_enable ) {
            return false;
        }
        // Get clients section details
        $section_details = array();
        $section_details = apply_filters( 'myself_pro_filter_clients_section_details', $section_details );

        if ( empty( $section_details ) ) {
            return;
        }

        // Render clients section now.
        myself_pro_render_clients_section( $section_details );
    }
endif;

if ( ! function_exists( 'myself_pro_get_clients_section_details' ) ) :
    /**
    * clients section details.
    *
    * @since Myself Pro 1.0.0
    * @param array $input clients section details.
    */
    function myself_pro_get_clients_section_details( $input ) {
        $options = myself_pro_get_theme_options();

        // Content type.
        $clients_content_type  = $options['clients_content_type'];
        $clients_count = ! empty( $options['clients_count'] ) ? $options['clients_count'] : 3;
        
        $content = array();
        switch ( $clients_content_type ) {
        	
            case 'page':
                $page_ids = array();

                for ( $i = 1; $i <= $clients_count; $i++ ) {
                    if ( ! empty( $options['clients_content_page_' . $i] ) )
                        $page_ids[] = $options['clients_content_page_' . $i];
                }
                
                $args = array(
                    'post_type'         => 'page',
                    'post__in'          => ( array ) $page_ids,
                    'posts_per_page'    => absint( $clients_count ),
                    'orderby'           => 'post__in',
                    );                    
            break;

            case 'post':
                $post_ids = array();

                for ( $i = 1; $i <= $clients_count; $i++ ) {
                    if ( ! empty( $options['clients_content_post_' . $i] ) )
                        $post_ids[] = $options['clients_content_post_' . $i];
                }
                
                $args = array(
                    'post_type'         => 'post',
                    'post__in'          => ( array ) $post_ids,
                    'posts_per_page'    => absint( $clients_count ),
                    'orderby'           => 'post__in',
                    'ignore_sticky_posts'   => true,
                    );                    
            break;

            case 'category':
                $cat_id = ! empty( $options['clients_content_category'] ) ? $options['clients_content_category'] : '';
                $args = array(
                    'post_type'         => 'post',
                    'posts_per_page'    => absint( $clients_count ),
                    'cat'               => absint( $cat_id ),
                    'ignore_sticky_posts'   => true,
                    );                    
            break;

            case 'custom':
                for ( $i = 1; $i <= $clients_count; $i++ ) {
                    $custom['image']        = ! empty( $options['clients_image_' . $i] ) ? $options['clients_image_' . $i] : '';
                    $custom['title']        = ! empty( $options['clients_title_' . $i] ) ? $options['clients_title_' . $i] : '';
                    $custom['url']          = ! empty( $options['clients_link_' . $i] ) ? $options['clients_link_' . $i] : '#';
                    $custom['excerpt']          = ! empty( $options['clients_description_' . $i] ) ? $options['clients_description_' . $i] : '';

                    // Push to the main array.
                    array_push( $content, $custom );
                }
            break;

            default:
            break;
        }

        if ( 'custom' !== $clients_content_type ) {
            // Run The Loop.
            $query = new WP_Query( $args );
            $i = 0;
            if ( $query->have_posts() ) : 
                while ( $query->have_posts() ) : $query->the_post();
                    $page_post['title']     = get_the_title();
                    $page_post['url']       = get_the_permalink();
                    $page_post['excerpt']   = myself_pro_trim_content( 5 );
                    $page_post['image']  	= has_post_thumbnail() ? get_the_post_thumbnail_url( get_the_id(), 'thumbnail' ) : '';

                    // Push to the main array.
                    array_push( $content, $page_post );
                    $i++;
                endwhile;
            endif;
            wp_reset_postdata();
        }
            
        if ( ! empty( $content ) ) {
            $input = $content;
        }
        return $input;
    }
endif;
// clients section content details.
add_filter( 'myself_pro_filter_clients_section_details', 'myself_pro_get_clients_section_details' );


if ( ! function_exists( 'myself_pro_render_clients_section' ) ) :
  /**
   * Start clients section
   *
   * @return string clients content
   * @since Myself Pro 1.0.0
   *
   */
   function myself_pro_render_clients_section( $content_details = array() ) {
        $options = myself_pro_get_theme_options();

        if ( empty( $content_details ) ) {
            return;
        } ?>

        <div id="my-clients" class="relative page-section">
            <div class="wrapper">
                <?php if ( ! empty( $options['clients_title'] ) ) : ?>
                    <div class="section-header text-center">
                        <h2 class="section-title"><?php echo esc_html( $options['clients_title'] ); ?></h2>
                    </div><!-- .section-header -->
                <?php endif;

                if ( ! empty( $options['clients_description'] ) || ( ! empty( $options['clients_btn_label'] ) && ! empty( $options['clients_btn_url'] ) ) ) : ?>
                    <div class="section-content">
                        <?php if ( ! empty( $options['clients_title'] ) ) : ?>
                            <p><?php echo wp_kses_post( $options['clients_description'] ); ?></p>
                        <?php endif; 

                        if ( ! empty( $options['clients_btn_label'] ) && ! empty( $options['clients_btn_url'] ) ) : ?>
                            <div class="read-more">
                                <a href="<?php echo esc_url( $options['clients_btn_url'] ); ?>" class="btn"><?php echo esc_html( $options['clients_btn_label'] ); ?></a>
                            </div><!-- .read-more -->
                        <?php endif; ?>
                    </div><!-- .section-content -->
                <?php endif; ?>

                <div class="clear"></div>

                <div class="happy-clients clear">
                    <?php foreach ( $content_details as $content ) : ?>
                        <article>
                            <?php if ( ! empty( $content['image'] ) ) : ?>
                                <div class="featured-image">
                                    <a href="<?php echo esc_url( $content['url'] ); ?>"><img src="<?php echo esc_url( $content['image'] ); ?>" alt="<?php echo esc_attr( $content['title'] ); ?>"></a>
                                </div><!-- .featured-image -->
                            <?php endif; 

                            if ( ! empty( $content['title'] ) || ! empty( $content['excerpt'] ) ) : ?>
                                <header class="entry-header">
                                    <?php if ( ! empty( $content['title'] ) ) : ?>
                                        <h2 class="entry-title"><a href="<?php echo esc_url( $content['url'] ); ?>"><?php echo esc_html( $content['title'] ); ?></a></h2>
                                    <?php endif; 

                                    if ( ! empty( $content['excerpt'] ) ) : ?>
                                        <p><?php echo wp_kses_post( $content['excerpt'] ); ?></p>
                                    <?php endif; ?>
                                </header>
                            <?php endif; ?>
                        </article>
                    <?php endforeach; ?>

                    <?php if ( ! empty( $options['clients_separator_image'] ) ) : ?>
                        <div class="center-featured-image">
                            <img src="<?php echo esc_url( $options['clients_separator_image'] ); ?>">
                        </div><!-- .center-featured-image -->
                    <?php endif; ?>

                </div><!-- .happy-clients -->
            </div><!-- .wrapper -->
        </div><!-- #my-clients -->

    <?php }
endif;